//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#include "bbcreaVtkReadMHDPlane.h"
#include "bbcreaVtkPackage.h"

#include "stdio.h"


#define _LARGEFILE64_SOURCE

#include <stdio.h>
#include <sys/types.h>

#if defined(_WIN32)
#else
#include <unistd.h>
#endif // defined(_WIN32)

#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <sys/stat.h>
#include <fcntl.h>

namespace bbcreaVtk
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaVtk,ReadMHDPlane)
BBTK_BLACK_BOX_IMPLEMENTATION(ReadMHDPlane,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 


vtkImageData* ReadMHDPlane::CreateDefaultImage()
{
	int i;
	int sizeX, sizeY, sizeZ;
	sizeX = 200;
	sizeY = sizeX;
	sizeZ = 1;
	vtkImageData *newImage = vtkImageData::New();
   	newImage->Initialize();
   	newImage->SetScalarTypeToUnsignedChar();
   	newImage->SetSpacing( 1,1,1 );
   	newImage->SetDimensions(  sizeX,sizeY,sizeZ );
   	newImage->SetWholeExtent(0,  sizeX-1,0,sizeY-1,0,sizeZ-1 );
   	newImage->SetExtent(0,  sizeX-1,0,sizeY-1,0,sizeZ-1 );
   	newImage->SetNumberOfScalarComponents(1);
   	newImage->AllocateScalars();
   	newImage->Update();
	memset ( (void*)newImage->GetScalarPointer(), 0, sizeX*sizeY*1 );
   	for (i=0; i<sizeX; i++)
   	{
		newImage->SetScalarComponentFromDouble(i,i,0, 0, 255 );
		newImage->SetScalarComponentFromDouble(i,sizeY-1-i,0, 0, 255 );
  	} // for i
	return newImage;
} 


void ReadMHDPlane::ReadNormalMHD()
{
// THE MAIN PROCESSING METHOD BODY
//   Here we simply set the input 'In' value to the output 'Out'
//   And print out the output value
// INPUT/OUTPUT ACCESSORS ARE OF THE FORM :
//    void bbSet{Input|Output}NAME(const TYPE&)
//    const TYPE& bbGet{Input|Output}NAME() const 
//    Where :
//    * NAME is the name of the input/output
//      (the one provided in the attribute 'name' of the tag 'input')
//    * TYPE is the C++ type of the input/output
//      (the one provided in the attribute 'type' of the tag 'input')

//    bbSetOutputOut( bbGetInputIn() );
//    std::cout << "Output value = " <<bbGetOutputOut() << std::endl;

	std::string inputfilename;
	int slice;
	int width;
	long long dataSize;


	if (bbGetInputDirectionPlane()=="XY")
	{
		inputfilename=bbGetInputFileName();
	} // if XY


	if ((bbGetInputDirectionPlane()=="YZ") || (bbGetInputDirectionPlane()=="ZX"))
	{
		//-- Split FileName
  		std::size_t found		=	bbGetInputFileName().find_last_of("/\\");
		std::string path		=	bbGetInputFileName().substr(0,found+1);
		std::string filename	=	bbGetInputFileName().substr(found+1);
#ifdef _WIN32
		path=path+"YZ_ZX\\";
#else
		path=path+"YZ_ZX/";
#endif
		if (bbGetInputDirectionPlane()=="YZ") 
		{ 
			inputfilename = path+filename+"_YZ.mhd";  
		} // if YZ

		if (bbGetInputDirectionPlane()=="ZX")
		{
			inputfilename = path+filename+"_ZX.mhd";
		} // XZ
	} // if YZ || XZ

	width = bbGetInputWidth();
	if (width<=0 ) { width=1; }

	slice = bbGetInputSlice();
	if (slice<0 ) { slice=0; }

	vtkImageData *newImage;
	long long newHeaderSize;
    std::string newFileName=inputfilename+"-OneSlice";

    int sx,sy,sz;
    char mystring[250];
    char strTmp[20];
	bool ok=true;
    FILE *ffIn	= fopen(inputfilename.c_str(),"r");
	if (ffIn!=NULL)
	{
	    FILE *ffOut	= fopen(newFileName.c_str(),"w");

    	while(!feof(ffIn))
    	{
    	    strcpy(mystring,"\n");
   			fgets(mystring,250,ffIn);
   	     	if (strncmp("NDims",mystring,5)==0) 
			{
				if (width==1) 
				{ 
					strcpy(mystring,"NDims = 2\n"); 
				} else {
					strcpy(mystring,"NDims = 3\n"); 
				}
			}
        	if (strncmp("DimSize",mystring,6)==0) 
			{
				sscanf(mystring,"%s %s %d %d %d",strTmp, strTmp, &sx, &sy,&sz);

				if (width==1) 
				{ 
					sprintf(mystring,"DimSize = %d %d\n",sx,sy);
				} else {
					sprintf(mystring,"DimSize = %d %d %d\n",sx,sy,width);
				}

    			newHeaderSize = (long long int)sx*(long long int)sy*(long long int)slice;
				if (bbGetInputSlice()>=sz) {ok=false;}
			} // if
        	if (strncmp("ElementType = MET_CHAR",mystring,22)==0) 			{ dataSize=sizeof(char); 			}
        	if (strncmp("ElementType = VTK_CHAR",mystring,22)==0) 			{ dataSize=sizeof(char); 			}
        	if (strncmp("ElementType = MET_UCHAR",mystring,23)==0) 			{ dataSize=sizeof(unsigned char); 	}
        	if (strncmp("ElementType = VTK_UNSIGNED_CHAR",mystring,31)==0) 	{ dataSize=sizeof(unsigned char); 	}
        	if (strncmp("ElementType = MET_USHORT",mystring,24)==0) 		{ dataSize=sizeof(unsigned short);	}
        	if (strncmp("ElementType = VTK_UNSIGNED_SHORT",mystring,32)==0) { dataSize=sizeof(unsigned short);	}
        	if (strncmp("ElementType = MET_SHORT",mystring,23)==0) 			{ dataSize=sizeof(short); 			}
        	if (strncmp("ElementType = VTK_SHORT",mystring,23)==0) 			{ dataSize=sizeof(short); 			}
        	if (strncmp("ElementType = MET_UINT",mystring,22)==0) 			{ dataSize=sizeof(unsigned int);	}
        	if (strncmp("ElementType = VTK_UNSIGNED_INT",mystring,30)==0) 	{ dataSize=sizeof(unsigned int);	}
        	if (strncmp("ElementType = MET_INT",mystring,21)==0) 			{ dataSize=sizeof(int);				}
        	if (strncmp("ElementType = VTK_INT",mystring,21)==0) 			{ dataSize=sizeof(int);				}
        	if (strncmp("ElementType = MET_FLOAT",mystring,23)==0) 			{ dataSize=sizeof(float); 			}
        	if (strncmp("ElementType = VTK_FLOAT",mystring,23)==0) 			{ dataSize=sizeof(float); 			}
        	if (strncmp("ElementType = MET_LONG",mystring,22)==0) 			{ dataSize=sizeof(long); 			}
        	if (strncmp("ElementType = VTK_LONG",mystring,22)==0) 			{ dataSize=sizeof(long); 			}
        	if (strncmp("ElementType = MET_DOUBLE",mystring,24)==0) 		{ dataSize=sizeof(double); 			}
        	if (strncmp("ElementType = VTK_DOUBLE",mystring,24)==0) 		{ dataSize=sizeof(double); 			}
			newHeaderSize=newHeaderSize*dataSize;

        	if (strncmp("Offset",mystring,6)==0) {strcpy(mystring,"Offset = 0 0 0\n");}
        	if (strncmp("HeaderSize",mystring,10)==0) {strcpy(mystring,"");}
        	if (strncmp("ElementDataFile",mystring,15)==0) 
			{
				fprintf(ffOut,"HeaderSize = %lld\n\n", newHeaderSize );
			} // if
        	fprintf(ffOut,mystring); 
    	} // while
   		fclose(ffIn);
   		fclose(ffOut);

		if (ok==true)
		{
   			vtkMetaImageReader * reader = vtkMetaImageReader::New();
   			reader->SetFileName( newFileName.c_str() );
   			reader->Update();
			newImage = reader->GetOutput();
		} // if ok
	} else {
		ok=false;
 		printf("EED ERROR: Problem openin:%s\n", inputfilename.c_str() );
 	}

	if (ok==false)
	{
		newImage=CreateDefaultImage();
	} // if ok

	bbSetOutputOut( newImage );
}





void ReadMHDPlane::Read64lseek()
{
	int 		slice;
	int 		width;

	width = bbGetInputWidth();
	if (width<=0 ) { width=1; }

	slice = bbGetInputSlice();
	if (slice<0 ) { slice=0; }

	int 		dimX=-1,dimY=-1,dimZ=-1;
	int 		dim=-1;
	std::string formattype("VOID");
	std::string elementdatafile("VOID");
	float	 	spcX=-1,spcY=-1,spcZ=-1;
	float 		ox=-1,oy=-1,oz=-1;
	long int 	headersize=0;

	vtkImageData *newImage=NULL;

	char mystring[250];
	char strTmp[30];
	char strTmp2[30];
	FILE *ffIn	= fopen(bbGetInputFileName().c_str(),"r");
	long long dataSize;

	if (ffIn!=NULL)
	{
		newImage = vtkImageData::New();

		while(!feof(ffIn))
		{
    	    strcpy(mystring,"\n");
   			fgets(mystring,250,ffIn);
   	     	if (strncmp("NDims",mystring,5)==0) 			{ sscanf(mystring,"%s %s %d"		,strTmp, strTmp, &dim); 				}
        	if (strncmp("DimSize",mystring,6)==0) 			{ sscanf(mystring,"%s %s %d %d %d"	,strTmp, strTmp, &dimX, &dimY,&dimZ);	} 
			if (strncmp("ElementType",mystring,11)==0) 		{ sscanf(mystring,"%s %s %s"		,strTmp, strTmp, strTmp2); formattype=strTmp2;			}
			if (strncmp("ElementSpacing",mystring,14)==0) 	{ sscanf(mystring,"%s %s %f %f %f"	,strTmp, strTmp, &spcX,&spcY,&spcZ);	}
			if (strncmp("ElementSize",mystring,11)==0) 		{ sscanf(mystring,"%s %s %f %f %f"	,strTmp, strTmp, &spcX,&spcY,&spcZ);	}
         	if (strncmp("Offset",mystring,6)==0) 			{ sscanf(mystring,"%s %s %f %f %f"	,strTmp, strTmp, &ox, &oy, &oz);		}
        	if (strncmp("HeaderSize",mystring,10)==0) 		{ sscanf(mystring,"%s %s %ld"		,strTmp, strTmp, &headersize);			}
			if (strncmp("ElementDataFile",mystring,15)==0) 	{ sscanf(mystring,"%s %s %s"		,strTmp, strTmp, strTmp2); elementdatafile=strTmp2;		}

        	if (strncmp("ElementType = MET_CHAR",mystring,22)==0) 			{ newImage->SetScalarTypeToChar(); 			dataSize=sizeof(char); 			}
        	if (strncmp("ElementType = VTK_CHAR",mystring,22)==0) 			{ newImage->SetScalarTypeToChar(); 			dataSize=sizeof(char); 			}
        	if (strncmp("ElementType = MET_UCHAR",mystring,23)==0) 			{ newImage->SetScalarTypeToUnsignedChar();	dataSize=sizeof(unsigned char); }
        	if (strncmp("ElementType = VTK_UNSIGNED_CHAR",mystring,31)==0) 	{ newImage->SetScalarTypeToUnsignedChar();	dataSize=sizeof(unsigned char); }
        	if (strncmp("ElementType = MET_USHORT",mystring,24)==0) 		{ newImage->SetScalarTypeToUnsignedShort();	dataSize=sizeof(unsigned short);}
        	if (strncmp("ElementType = VTK_UNSIGNED_SHORT",mystring,32)==0) { newImage->SetScalarTypeToUnsignedShort();	dataSize=sizeof(unsigned short);}
        	if (strncmp("ElementType = MET_SHORT",mystring,23)==0) 			{ newImage->SetScalarTypeToShort();			dataSize=sizeof(short); 		}
        	if (strncmp("ElementType = VTK_SHORT",mystring,23)==0) 			{ newImage->SetScalarTypeToShort();			dataSize=sizeof(short); 		}
        	if (strncmp("ElementType = MET_UINT",mystring,22)==0) 			{ newImage->SetScalarTypeToUnsignedInt();	dataSize=sizeof(unsigned int);	}
        	if (strncmp("ElementType = VTK_UNSIGNED_INT",mystring,30)==0) 	{ newImage->SetScalarTypeToUnsignedInt();	dataSize=sizeof(unsigned int);	}
        	if (strncmp("ElementType = MET_INT",mystring,21)==0) 			{ newImage->SetScalarTypeToInt();			dataSize=sizeof(int);			}
        	if (strncmp("ElementType = VTK_INT",mystring,21)==0) 			{ newImage->SetScalarTypeToInt();			dataSize=sizeof(int);			}
        	if (strncmp("ElementType = MET_FLOAT",mystring,23)==0) 			{ newImage->SetScalarTypeToFloat();			dataSize=sizeof(float); 		}
        	if (strncmp("ElementType = VTK_FLOAT",mystring,23)==0) 			{ newImage->SetScalarTypeToFloat();			dataSize=sizeof(float); 		}
        	if (strncmp("ElementType = MET_LONG",mystring,22)==0) 			{ newImage->SetScalarTypeToLong();			dataSize=sizeof(long); 			}
        	if (strncmp("ElementType = VTK_LONG",mystring,22)==0) 			{ newImage->SetScalarTypeToLong();			dataSize=sizeof(long); 			}
        	if (strncmp("ElementType = MET_DOUBLE",mystring,24)==0) 		{ newImage->SetScalarTypeToDouble();		dataSize=sizeof(double); 		}
        	if (strncmp("ElementType = VTK_DOUBLE",mystring,24)==0) 		{ newImage->SetScalarTypeToDouble();		dataSize=sizeof(double); 		}

    	} // while
   		fclose(ffIn);

   		newImage->Initialize();


		int 		fd;
		long long 	ret;
		std::size_t found;
		std::string filename;
		found					= bbGetInputFileName().find_last_of("/\\");
		filename 				= bbGetInputFileName().substr(0,found+1) + elementdatafile ;
		long long 	pos;

		long long lsize			= dimX*dimY*width *dataSize;


#if defined(_WIN32)
		   _sopen_s( &fd, filename.c_str(), _O_RDONLY, _SH_DENYNO, 0 );
#else
		fd = open ( filename.c_str() ,  O_RDONLY|O_LARGEFILE );
#endif // defined(_WIN32)


		if (fd < 0)
		{
			printf("EED ReadMHDPlane::Read64lseek   WARNNING! raw file not exist\n");
			fprintf(stderr, "%s\n", strerror(errno));
			newImage=CreateDefaultImage();
//			exit(1);
		} 	
		

		if ((bbGetInputDirectionPlane()=="XY") && (fd>=0)) 
		{ 
	   		newImage->SetSpacing( spcX,spcY,spcZ );
	   		newImage->SetDimensions(  dimX,dimY,width );
	   		newImage->SetWholeExtent(0,  dimX-1,0,dimY-1,0,width-1 );
	   		newImage->SetExtent(0,  dimX-1,0,dimY-1,0,width-1 );
	   		newImage->SetNumberOfScalarComponents(1);
	   		newImage->AllocateScalars();
	   		newImage->Update();
			pos = dimX*dimY*(long long)slice*dataSize;
#if defined(_WIN32)
			if (_lseeki64( fd, pos, SEEK_SET ) < 0)
#else
			if (lseek64(fd, pos, SEEK_SET) < 0) 
#endif // defined(_WIN32)
			{
				printf("EED ReadMHDPlane::Read64lseek \n");
				fprintf(stderr, "Failed seeking to %lld, %s\n", pos, strerror(errno));
				exit(1);
			}

			if ((ret = read(fd, newImage->GetScalarPointer() , lsize)) < 0) 
			{
				fprintf(stderr, "Failed reading: %s\n", strerror(errno));
				exit(1);
			}
		}  // if PLANE XY

		if ((bbGetInputDirectionPlane()=="XZ") && (fd>=0))
		{ 
	   		newImage->SetSpacing( spcX,spcZ,spcY );
	   		newImage->SetDimensions(  dimX,dimZ,width );
	   		newImage->SetWholeExtent(0,  dimX-1,0,dimZ-1,0,width-1 );
	   		newImage->SetExtent(0,  dimX-1,0,dimZ-1,0,width-1 );
	   		newImage->SetNumberOfScalarComponents(1);
	   		newImage->AllocateScalars();
	   		newImage->Update();
			int iWidth;
			for (iWidth=0;iWidth<width;iWidth++)
			{
				copy_XZ_plane(fd,newImage,slice+iWidth,iWidth,dimX,dimY,dimZ,dataSize);
			}
		}  // if PLANE XZ

		if ((bbGetInputDirectionPlane()=="YZ") && (fd>=0))
		{ 
	   		newImage->SetSpacing( spcY,spcZ,spcX );
	   		newImage->SetDimensions(  dimY,dimZ,width );
	   		newImage->SetWholeExtent(0,  dimY-1,0,dimZ-1,0,width-1 );
	   		newImage->SetExtent(0,  dimY-1,0,dimZ-1,0,width-1 );
	   		newImage->SetNumberOfScalarComponents(1);
	   		newImage->AllocateScalars();
	   		newImage->Update();
			int iWidth;
			for (iWidth=0;iWidth<width;iWidth++)
			{
				copy_YZ_plane(fd,newImage,slice+iWidth,iWidth,dimX,dimY,dimZ,dataSize);
			}

		}  // if PLANE YZ	
#if defined(_WIN32)
		_close (fd);
#else
		close (fd);
#endif // defined(_WIN32)
	} else {
		newImage=CreateDefaultImage();
	} // if  ffIn

	bbSetOutputOut( newImage );
}


void ReadMHDPlane::copy_YZ_plane(int fd,vtkImageData *newImage,int slice,int iWidth,int dimX,int dimY,int dimZ,int dataSize)
{
	long long int j;
	long long int i;
	long long 	ret;
	long long 	pos;
	long long sizeBytesPlane = dimX*dimY*dataSize;
	char *pImage;
	for (j=0;j<dimZ;j++)
	{
		for (i=0;i<dimY;i++)
		{
			pos = ((long long int)slice+iWidth + i*dimX + j*dimX*dimY)*dataSize ;
#if defined(_WIN32)
			if (_lseeki64( fd, pos , SEEK_SET ) < 0)
#else
			if (lseek64(fd, pos , SEEK_SET) < 0) 
#endif // defined(_WIN32)
			{
				printf("EED ReadMHDPlane::Read64lseek \n");
				fprintf(stderr, "Failed seeking to %lld, %s\n", pos, strerror(errno));
				exit(1);
			}

			pImage=(char*)(newImage->GetScalarPointer(i, dimZ-1-j,iWidth ));
			if ((ret = read(fd, pImage , dataSize)) < 0) 
			{
				fprintf(stderr, "Failed reading: %s\n", strerror(errno));
				exit(1);
			}
			} // for i
		} // for j
}


void ReadMHDPlane::copy_XZ_plane(int fd,vtkImageData *newImage,int slice,int iWidth,int dimX,int dimY,int dimZ,int dataSize)
{
	long long int j;
	long long 	ret;
	long long 	pos;
	pos = dimX*(long long int)slice*dataSize;
	long long sizeBytesPlane = dimX*dimY*dataSize;
	char *pImage = (char*)( newImage->GetScalarPointer(0,0,iWidth) );
	for (j=dimZ-1;j>=0;j--)
	{
#if defined(_WIN32)
		if (_lseeki64( fd, pos + j*sizeBytesPlane , SEEK_SET ) < 0)
#else
		if (lseek64(fd, pos + j*sizeBytesPlane , SEEK_SET) < 0) 
#endif // defined(_WIN32)
		{
			printf("EED ReadMHDPlane::Read64lseek \n");
			fprintf(stderr, "Failed seeking to %lld, %s\n", pos, strerror(errno));
			exit(1);
		}

		if ((ret = read(fd, pImage , dimX*dataSize)) < 0) 
		{
			fprintf(stderr, "Failed reading: %s\n", strerror(errno));
			exit(1);
		}
		pImage = pImage+dimX*dataSize;
	} // for j
}



void ReadMHDPlane::Process()
{
	if (bbGetInputType()==0)
	{
		ReadNormalMHD();
	}	

	if (bbGetInputType()==1)
	{
		Read64lseek();
	}	

}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void ReadMHDPlane::bbUserSetDefaultValues()
{

//  SET HERE THE DEFAULT INPUT/OUTPUT VALUES OF YOUR BOX 
//    Here we initialize the input 'In' to 0
   bbSetInputFileName("");
   bbSetInputSlice(0);
   bbSetInputType(1);
   bbSetInputWidth(1);
   bbSetInputDirectionPlane("XY");
  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void ReadMHDPlane::bbUserInitializeProcessing()
{

//  THE INITIALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should allocate the internal/output pointers 
//    if any 

  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void ReadMHDPlane::bbUserFinalizeProcessing()
{

//  THE FINALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should desallocate the internal/output pointers 
//    if any
  
}
}
// EO namespace bbcreaVtk


